#ifndef CGGEOMETRY_H
#define CGGEOMETRY_H
#endif

/*CGPoint

Represents a point in a two-dimensional coordinate system.

struct CGPoint {
   float x;
   float y;
};
typedef struct CGPoint CGPoint;
Fields
x

The x-coordinate of the point.
y

The y-coordinate of the point.
Availability
Available in Mac OS X v10.0 and later.*/
struct CGPoint {
   float x;
   float y;
};
typedef struct CGPoint CGPoint;

/*CGSize

Represents the dimensions of width and height.

struct CGSize {
   float width;
   float height;
};
typedef struct CGSize CGSize;
Fields
width

A width value.
height

A height value.
Availability
Available in Mac OS X v10.0 and later.*/
struct CGSize {
   float width;
   float height;
};
typedef struct CGSize CGSize;

/*CGRect

Represents the location and dimensions of a rectangle.

struct CGRect {
   CGPoint origin;
   CGSize size;
};
typedef struct CGRect CGRect;
Fields
origin

A CGPoint structure that specifies the coordinates of the rectangles origin. 
size

A CGSize structure that specifies the height and width of the rectangle. 
Availability
Available in Mac OS X v10.0 and later.*/
struct CGRect {
   CGPoint origin;
   CGSize size;
};
typedef struct CGRect CGRect;

